<template>
    <div class="edit-popup">
        <el-card class="!border-none" shadow="never">
            <el-page-header :content="$route.meta.title" @back="$router.back()" />
        </el-card>
        <el-card class="mt-4 !border-none" shadow="never">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="试卷分类" prop="category_uid">
                    <el-cascader v-model="formData.category_uid" :options="optionsData.category" :props="props"
                        @change="handleChange" style="width: 100%" />
                </el-form-item>
                <el-form-item label="试卷封面" prop="image">
                    <material-picker v-model="formData.image" />
                </el-form-item>
                <!-- <el-form-item label="试卷海报" prop="mini_qr_code">
                    <material-picker v-model="formData.mini_qr_code" />
                </el-form-item> -->
                <el-form-item label="试卷配图" prop="picture">
                    <material-picker v-model="formData.picture" :limit="4" />
                </el-form-item>
                <el-form-item label="试卷名称" prop="title">
                    <el-input v-model="formData.title" clearable placeholder="请输入试卷名称" />
                </el-form-item>
                <el-form-item label="试卷描述" prop="remark">
                    <el-input type="textarea" :autosize="{ minRows: 3, maxRows: 6 }" maxlength="50" show-word-limit
                        v-model="formData.remark" clearable placeholder="请输入试卷描述" />
                </el-form-item>
                <el-form-item label="试卷类型" prop="is_activity">
                    <el-radio-group v-model="formData.is_activity" placeholder="请选择试卷所属类别">
                        <el-radio v-for="(item, index) in dictData.collection_activity" :key="index" :label="item.value">
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="试卷作者" prop="author">
                    <el-input v-model="formData.author" style="width: 100%" clearable placeholder="请输入试卷作者" />
                </el-form-item>
                <el-form-item label="答题日期" prop="date">
                    <div>
                        <el-date-picker v-model="formData.date" type="daterange" range-separator="至"
                            start-placeholder="开始日期" end-placeholder="结束日期" value-format="YYYY-MM-DD" />
                        <div class="form-tips">答题时间截止后之后，仍会在用户端进行显示，但用户无法进行答题；答题结束之后，关闭用户查看，选择下架操作即可。</div>
                    </div>
                </el-form-item>
                <el-form-item label="作答时间" prop="time">
                    <el-time-picker v-model="formData.time" clearable value-format="HH:mm:ss" placeholder="选择作答时间"
                        style="width: 100%;">
                    </el-time-picker>
                </el-form-item>
                <el-form-item label="试卷年份" prop="year">
                    <el-date-picker v-model="formData.year" clearable type="year" value-format="YYYY" placeholder="选择答题时间">
                    </el-date-picker>
                </el-form-item>
                <el-form-item label="试卷难度" prop="level">
                    <el-select v-model="formData.level" clearable placeholder="请选择试卷难度">
                        <el-option v-for="(item, index) in dictData.exam_level" :key="index" :label="item.name"
                            :value="parseInt(item.value)" />
                    </el-select>
                </el-form-item>
                <el-form-item label="试卷类型" prop="collection_type">
                    <el-select v-model="formData.collection_type" clearable placeholder="请选择试卷类型">
                        <el-option v-for="(item, index) in dictData.collection_type" :key="index" :label="item.name"
                            :value="item.value" />
                    </el-select>
                </el-form-item>
                <el-form-item label="开启下载" prop="is_download">
                    <el-radio-group v-model="formData.is_download" placeholder="是否开启下载">
                        <el-radio v-for="(item, index) in dictData.download_status" :key="index"
                            :label="parseInt(item.value)">
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="链接地址" prop="attache">
                    <el-input v-model="formData.attache" clearable placeholder="请输入试卷链接地址" />
                    <div class="form-tips">当试卷为附件试卷时，请填写试卷地址。要求必须是https协议，可直接访问的地址。</div>
                </el-form-item>
                <el-form-item label="是否留资" prop="form_state">
                    <el-radio-group v-model="formData.form_state" placeholder="是否留资">
                        <el-radio
                            v-for="(item, index) in dictData.form_state"
                            :key="index"
                            :label="parseInt(item.value)"
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="是否发布" prop="is_show">
                    <div>
                        <el-radio-group style="width: 100%;" v-model="formData.is_show" placeholder="是否发布">
                            <el-radio v-for="(item, index) in dictData.show_status" :key="index"
                                :label="parseInt(item.value)">
                                {{ item.name }}
                            </el-radio>
                        </el-radio-group>
                    </div>
                    <!-- <div class="form-tips">选择发布，在平台审核通过之后，会立即展示在用户端。</div> -->
                </el-form-item>
                <!-- <el-form-item label="显示权重" prop="sort">
                    <div>
                        <el-input-number v-model="formData.sort" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item> -->
                <el-form-item label="答题次数" prop="repeat_count">
                    <div>
                        <el-input-number v-model="formData.repeat_count" :min="0" />
                        <div class="form-tips">限制用户重复答题次数，默认为0表示不限制用户答题次数。</div>
                    </div>
                </el-form-item>
                <!-- <el-form-item label="收藏数量" prop="collect">
                    <div>
                        <el-input-number v-model="formData.collect" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item> -->
                <!-- <el-form-item label="答题人数" prop="submit">
                    <div>
                        <el-input-number v-model="formData.submit" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item> -->
                <!-- <el-form-item label="推荐状态" prop="recommend">
                    <el-radio-group v-model="formData.recommend" placeholder="请选择是否推荐">
                        <el-radio
                            v-for="(item, index) in dictData.show_status"
                            :key="index"
                            :label="parseInt(item.value)"
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item> -->
                <!-- <el-form-item label="展示风格" prop="show_style">
                    <el-radio-group v-model="formData.show_style" placeholder="请选择试卷展示风格">
                        <el-radio
                            v-for="(item, index) in dictData.show_style"
                            :key="index"
                            :label="item.value"
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item> -->
                <!-- <el-form-item label="是否收费" prop="is_free">
                    <el-select v-model="formData.is_free" clearable placeholder="请选择是否收费">
                        <el-option
                            v-for="(item, index) in dictData.free_status"
                            :key="index"
                            :label="item.name"
                            :value="parseInt(item.value)"
                        />
                    </el-select>
                </el-form-item> -->
                <!-- <el-form-item label="试卷价格" prop="money">
                    <div>
                        <el-input-number
                            v-model="formData.money"
                            :min="0"
                            :step="0.01"
                            @change="moneyChange"
                        />
                        <div class="form-tips">试卷为单价收费时该值生效</div>
                    </div>
                </el-form-item> -->
                <!-- <el-form-item label="答题积分" prop="score">
                    <div>
                        <el-input-number
                            v-model="formData.score"
                            :min="0"
                            :step="1"
                            @change="score"
                        />
                        <div class="form-tips">答题奖励积分，填写0则以用户答对的试题分数计算，填写则不管答对多少道试题只以改分数进行计算。</div>
                    </div>
                </el-form-item> -->
                <el-form-item label="试卷说明" prop="content">
                    <editor class="flex-1" v-model="formData.content" :height="auto" />
                </el-form-item>
            </el-form>
        </el-card>
        <footer-btns>
            <el-button type="primary" @click="handleSave">保存</el-button>
        </footer-btns>
    </div>
</template>

<script lang="ts" setup name="examCollectionEdit">
import type { FormInstance } from 'element-plus'
import { useDictOptions, useDictData } from '@/hooks/useDictOptions'
import {
    apiExamCollectionAdd,
    apiExamCollectionEdit,
    apiExamCollectionDetail
} from '@/api/exam_collection'
import { apiExamCategoryTree } from '@/api/exam_category'
import type { PropType } from 'vue'

defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const route = useRoute()
const router = useRouter()
// 表单数据
const formData = reactive({
    id: '',
    title: '',
    is_show: 1,
    sort: 0,
    image: '',
    time: '',
    collect: '',
    submit: '',
    recommend: 2,
    content: '',
    category_uid: '',
    level: '',
    author: '',
    remark: '',
    is_free: 2,
    mini_qr_code: '',
    picture: [],
    year: '',
    money: 0.0,
    start_date: '',
    end_date: '',
    collection_type: '',
    repeat_count: 0,
    date: [],
    show_style: '',
    attache: '',
    is_download: 2,
    score: 0.00,
    is_activity: 'collection',
    form_state: 2,
})

// const { removeTab } = useMultipleTabs()
const formRef = shallowRef<FormInstance>()
// 表单验证
const formRules = reactive<any>({
    title: [
        {
            required: true,
            message: '请输入试卷名称',
            trigger: ['blur']
        }
    ],
    year: [
        {
            required: true,
            message: '请选择试题年份',
            trigger: ['blur']
        }
    ],
    is_show: [
        {
            required: true,
            message: '请选择显示状态',
            trigger: ['blur']
        }
    ],
    sort: [
        {
            required: true,
            message: '请输入显示权重',
            trigger: ['blur']
        }
    ],
    image: [
        {
            required: true,
            message: '请选择试卷封面',
            trigger: ['blur']
        }
    ],
    time: [
        {
            required: true,
            message: '请选择作答时间',
            trigger: ['blur']
        }
    ],
    date: [
        {
            required: true,
            message: '请选择答题时间范围',
            trigger: ['blur']
        }
    ],
    collect: [
        {
            required: true,
            message: '请输入收藏数量',
            trigger: ['blur']
        }
    ],
    submit: [
        {
            required: true,
            message: '请输入答题数量',
            trigger: ['blur']
        }
    ],
    recommend: [
        {
            required: true,
            message: '请选择是否推荐',
            trigger: ['blur']
        }
    ],
    content: [
        {
            required: true,
            message: '请输入试卷描述',
            trigger: ['blur']
        }
    ],
    category_uid: [
        {
            required: true,
            message: '请选择试卷分类',
            trigger: ['blur']
        }
    ],
    level: [
        {
            required: true,
            message: '请选择试卷难度',
            trigger: ['blur']
        }
    ],
    author: [
        {
            required: true,
            message: '请输入试卷作者',
            trigger: ['blur']
        }
    ],
    is_free: [
        {
            required: true,
            message: '请选择是否收费',
            trigger: ['blur']
        }
    ],
    picture: [
        {
            required: true,
            message: '请选择试卷配图',
            trigger: ['blur']
        }
    ],
    collection_type: [
        {
            required: true,
            message: '试卷类型不能为空',
            trigger: ['blur']
        }
    ],
    show_style: [
        {
            require: true,
            message: '试卷展示风格必选',
            trigger: ['blur']
        }
    ],
    is_activity: [
        {
            require: true,
            message: '试卷类别必选',
            trigger: ['blur']
        }
    ],
})

const getDetails = async () => {
    const data = await apiExamCollectionDetail({
        id: route.query.id
    })
    Object.keys(formData).forEach((key) => {
        //@ts-ignore
        formData[key] = data[key]
    })
}

const { dictData } = useDictData('show_status,free_status,exam_level,collection_type,show_style,download_status,collection_activity,form_state')

const { optionsData } = useDictOptions<{
    category: any[]
}>({
    category: {
        api: apiExamCategoryTree
    }
})

// 试卷分类选择
const handleChange = (value) => {
    formData.category_uid = value[1]
}


// 试卷价格 TODO 设置试卷价格未生效
const moneyChange = (value: number) => {
    formData.money = value
}

// 设置答题积分
const scoreChage = (value: number) => {
    formData.score = value
}

const handleSave = async () => {
    await formRef.value?.validate()
    if (route.query.id) {
        await apiExamCollectionEdit(formData)
    } else {
        await apiExamCollectionAdd(formData)
    }
    router.back()
}

route.query.id && getDetails()
</script>
